#ifndef EFL_GENERATED_EFL_CONTROL_HH
#define EFL_GENERATED_EFL_CONTROL_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "efl_control.eo.h"
}


namespace efl {

struct control
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit control(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit control(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   control(control const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~control() {}

   /// @param priority The priority of the object
   ///
   int priority_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::efl_control_priority_get());
      return _tmp_ret;
   }

   /// @param priority The priority of the object
   ///
   void priority_set(int priority_) const
   {
      eo_do(_eo_ptr(), ::efl_control_priority_set(priority_));
   }

   /// @param suspend Controls whether the object is suspended or not.
   ///
   bool suspend_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::efl_control_suspend_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param suspend Controls whether the object is suspended or not.
   ///
   void suspend_set(bool suspend_) const
   {
      eo_do(_eo_ptr(), ::efl_control_suspend_set(efl::eolian::to_c(suspend_)));
   }

   static Eo_Class const* _eo_class()
   {
      return(EFL_CONTROL_INTERFACE);
   }

private:
};
} 

template <typename T>
int efl_control_priority_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->priority_get();
}

template <typename T>
void efl_control_priority_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int priority_)
{
   static_cast<T*>(self->this_)->priority_set(priority_);
}

template <typename T>
bool efl_control_suspend_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->suspend_get();
}

template <typename T>
void efl_control_suspend_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool suspend_)
{
   static_cast<T*>(self->this_)->suspend_set(efl::eolian::to_cxx<bool>(suspend_, std::tuple<std::false_type>()));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< efl::control >
{
   template <typename T>
   struct type
   {
      virtual int priority_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::efl_control_priority_get());
            return _tmp_ret;
      }

      virtual void priority_set(int priority_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::efl_control_priority_set(priority_));
      }

      virtual bool suspend_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::efl_control_suspend_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void suspend_set(bool suspend_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::efl_control_suspend_set(efl::eolian::to_c(suspend_)));
      }

   };
};


template<>
struct operation_description_class_size< efl::control >
{
   static const int value = 4;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<efl::control>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::efl_control_priority_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::efl_control_priority_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::efl_control_priority_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::efl_control_priority_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::efl_control_suspend_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::efl_control_suspend_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::efl_control_suspend_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::efl_control_suspend_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< efl::control >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<efl::control, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< efl::control>
{
   template <typename U>
   struct type
   {
      operator efl::control() const
      {
         return efl::control(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      int priority_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::efl_control_priority_get());
            return _tmp_ret;
      }

      void priority_set(int priority_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::efl_control_priority_set(priority_));
      }

      bool suspend_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::efl_control_suspend_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void suspend_set(bool suspend_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::efl_control_suspend_set(efl::eolian::to_c(suspend_)));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<efl::control>)
{
   return (EFL_CONTROL_INTERFACE);
}

} } }
#endif // EFL_GENERATED_EFL_CONTROL_HH

